// Copyright 1991 (c),   Lake View Software
//                       4321 Harborough Rd.
//                       Columbus, OH 43220
// LVS Windows Library
// br.cpp

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "wintools.hpp"
#include "winmenu.hpp"
#include "win_prn.hpp"
#include "WinMouse.Hpp"
#include "pxengine.h"

#pragma hdrstop			// stop header file compile
#include "br.hpp"

TABLEHANDLE  tblHandle = 0;
RECORDHANDLE recHandle = 0;
RECORDNUMBER recs;
int flds;
int keys;

char *NAME = " Paradox Table Browser v1.6 ";

void main (int argv, char **argc)
{
    if (argv != 1)
        Parse_Commands (argv, argc);

	if (Error (PXInit ()))
		exit (1);

    VGA_setblink (W_OFF);
    VGA_fontload ();

    WinObj Main_Scr;
	Main_Scr.open (2, 0, 24, 79, W_NOBORDER, _BLACK|LGREY);
	Main_Scr.set_fill ('');
	Main_Scr.clr_win ();

    WinObj Logo;

    Logo.open (8, 26, 14, 53, W_NOBORDER, _BLACK|LCYAN);
    Logo.center (1, NAME);
    Logo.set_attr (_BLACK|WHITE);
    Logo.center (3, "Copyright (c) 1991");
    Logo.set_attr (_BLACK|DGREY);
    Logo.center (4, "by");
    Logo.set_attr (_BLACK|BLUE);
    Logo.center (5, "Lake View Software");

    // Init mouse driver
    Win_mouse_mode (M_FULL);

	Main_Menu ();

	PXExit ();
}

static void About ()
{
    WinObj w;

    w.open (3, 15, 14, 65, W_SINGLE, _BLACK|LBLUE, _BLACK|WHITE);
    w.shadow ();
    w.title (NAME);

    w.puts (3, 6, "LVS Windows from Lake View Software");
    w.set_attr (_BLACK|LGREY);
    w.puts (1, 1, "BR was written using:");
    w.set_attr (_BLACK|CYAN);
    w.puts (5, 6, "Paradox Engine from Borland International");
    w.set_attr (_BLACK|WHITE);
    w.puts (7, 6, "Borland C++ from Borland International");
    w.get_key (W_NOECHO, 25);
}


void Main_Menu ()
{
	WinMenu m;

	m.open (0, 0, 0, 79, W_NOBORDER, _LGREY|BLACK);
	m.message_line (1);
	m.set_keyattr (_LGREY|RED);
	m.set_barattr (_RED|WHITE);

	m.prompt (0,  0,  1, " Table ", "Open, Close, New, Quit", 'T');
	m.prompt (0,  9,  2, " Browse ", "Browse the current table", 'B');
	m.prompt (0, 19,  4, " Print ", "Print the current table structure", 'P');
	m.prompt (0, 28,  5, " System ", "Shell to DOS", 'S');
    m.prompt (0, 38,  6, " About ", "About BR", 'A');
    m.prompt (0, 47,  0, " Quit ",   "Quit to DOS", 'Q');

	int choice = 1;
	while (choice)
		{
		choice = m.read (choice);
		switch (choice)
			{
			case 1:
				Table_Menu ();
				break;
			case 2:
				Browse ();
				break;

			case 4:
                Print_Struct ();
				break;

			case 5:
				clrscr ();
				puts ("type 'EXIT' to return\n\n");
				system ("");
				clrscr ();
				m.update_all ();        // restore the screen
				break;

            case 6:
                About ();
                break;
			}
		}
}

int Table_Menu ()
{
	WinMenu m;

	m.open (0, 0, 0, 79, W_NOBORDER, _LGREY|BLACK);
	m.message_line (1);
	m.set_keyattr (_LGREY|RED);
	m.set_barattr (_RED|WHITE);

	m.prompt (0,  0 , 1, " Open ", "Open a Paradox table", 'O');
    m.prompt (0,  8,  6, " Browse ", "Browse a Paradox table", 'B');
	m.prompt (0, 18, 2, " Close ", "Close the current table", 'C');
    m.prompt (0, 27, 3, " Decrypt ", "Decrypt a table", 'D');
    m.prompt (0, 38, 4, " Encrypt ", "Encrypt a table", 'E');
	m.prompt (0, 49, 5, " New ", "Create a new Paradox table", 'N');
	m.prompt (0, 56,  7," Print ", "Print the current table structure", 'P');
	m.prompt (0, 65, 0, " Quit ", "Return to main menu", 'Q');

	int choice = 1;
    while (choice)
        {
        Say_Wait (0);
        choice = m.read (choice);

        if (choice == W_ESCAPE)
            break;

        switch (choice)
	        {
            case 1:
	    		Table_Open ();
                break;
    		case 2:
	    		Table_Close ();
                break;
            case 3:
                Table_Decrypt ();
                break;
            case 4:
                Table_Encrypt ();
                break;
    		case 5:
	    		New_Table ();
		    	break;
            case 6:
                Browse ();
                break;
            case 7:
                Print_Struct ();
                break;
    		}
        }
	return 0;
}

void Table_Decrypt ()
{
    if (tblHandle)
        Table_Close ();

	char *file = Win_File_Pick ("*.DB", _CYAN|BLACK, _CYAN|RED);
    if (!file)
        return;

    WinObj w;
    w.open (5, 10, 7, 40, W_SINGLE,  _GREEN|BLACK);
    w.shadow ();
    w.title (" Decrypt Table ");
    w.printf (" Password: ");
    static char password[16] = "";
    w.get (0, w.wherex (), password, 'A', 15);
    if (w.read () == ESC)
        return;

    Say_Wait (1);
    if (Error (PXPswAdd (password)))
        return;
    Error (PXTblDecrypt (file));
    Error (PXPswDel (password));
}

void Table_Encrypt ()
{
    if (tblHandle)
        Table_Close ();

	char *file = Win_File_Pick ("*.DB");
    if (!file)
        return;

    WinObj w;
    w.open (5, 10, 7, 40, W_SINGLE,  _GREEN|BLACK);
    w.shadow ();
    w.title (" Encrypt Table ");
    w.printf (" Password: ");
    static char password[16] = "";
    w.get (0, w.wherex (), password, 'A', 15);
    if (w.read () == ESC)
        return;

    Say_Wait (1);
    Error (PXTblEncrypt (file, password));
}

void Table_Open ()
{
	char *file = Win_File_Pick ("*.DB");
	if (!file)
        return;
	if (tblHandle)
		Table_Close ();

    int Protected;
    if (Error (PXTblProtected (file, &Protected)))
        return;
    if (Protected)
        {
        WinObj w;
        w.open (5, 10, 7, 40, W_SINGLE, _GREEN|BLACK);
        w.shadow ();
        w.title (" Table has Password ");
        w.printf (" Password: ");
        static char password[16] = "";
        if (password[0])
            PXPswDel (password);
        w.get (0, w.wherex (), password, 'A', 15);
        if (w.read () == ESC)
            return;
        if (Error (PXPswAdd (password)))
            return;
        }

	if (!Error (PXTblOpen (file, &tblHandle, 0, 1)))
		Error (PXRecBufOpen (tblHandle, &recHandle));

	Show_Status ();
	Show_Struct ();			// Open and display structure window
}

void Table_Close ()
{
	if (!tblHandle)
		return;

	Error (PXTblClose (tblHandle));

	tblHandle = 0;
	Show_Status ();
	Show_Struct ();				// Close structure window
}

void Show_Struct ()
{
	static WinObj s;
	if (!tblHandle )
		{
		s.close ();
		return;
		}

	s.set_virtual (flds+1, 0);
	int height = flds;
	if (height > 18)
		height = 18;
	s.open (2, 39, 4 + height, 78, W_DOUSIN, _CYAN|RED, _CYAN|BLUE);
    s.shadow ();
	s.title (" Table Structure ");

	s.printf (0, 6, "Field");
	s.printf (0, 32, "Type");
	s.set_attr (_CYAN|BLACK);
	for (unsigned i=1; i<=flds; i++)
		{
        s.printf (i, 0, "%3d.", i);

		char str [26];
		Error (PXFldName (tblHandle, i, 26, str));
		s.printf (i, 6, str);

		Error (PXFldType (tblHandle, i, 26, str));
		s.printf (i, 32, str);
		}
}

void Print_Struct ()
{
	if (!tblHandle )
		return;

    if (!Win_Get_YN ("Printer ready (y/n)"))
        return;

	Win_Prn p;

	int height = flds + 5;
	if (height < 66)
		height = 66;

    p.set_virtual (height, 80);

    if (p.open () != W_OK)
        {
        Win_Error ("Printer open error");
        return;
        }

    char name[100];
	if (Error (PXTblName (tblHandle, 100, name)))
		return;
    p.printf (0, 2, "Structure for: %s", name);

	p.puts (3, 8, "Field Name");
    p.puts (4, 8, "-------------------------");
	p.puts (3, 34, "Type");
    p.puts (4, 34, "-----");

	for (unsigned i=1; i<=flds; i++)
		{
        p.printf (i + 4, 2, "%3d.", i);

		char str [26];
		Error (PXFldName (tblHandle, i, 26, str));
		p.puts (i + 4, 8, str);

		Error (PXFldType (tblHandle, i, 26, str));
		p.puts (i + 4, 34, str);
		}

    p.print_page ();
}

void Show_Status ()
{
	static WinObj s;


	if (!s.is_open ())
        {
		s.open (24, 0, 24, 79, W_NOBORDER, _LGREY|BLACK);
        }

	s.clr_win ();

	if (!tblHandle)
		return;

	char name [100];

	if (Error (PXTblName (tblHandle, 100, name)))
		return;

	s.printf (0, 1, name);

	Error (PXTblNRecs (tblHandle, &recs));
	Error (PXKeyNFlds (tblHandle, &keys));
	Error (PXRecNFlds (tblHandle, &flds));

	s.printf ("    -- %ld Recs,  %d Flds,  %d Flds in Key --",
			recs, flds, keys);
}


int Error(int rc)
{
	if (rc != PXSUCCESS)
		{
		WinObj w;
		char *str = PXErrMsg (rc);
		Win_Error (str);
		}
	return rc;
}
